unit ACRConst;

interface

{$I ACRVer.inc}

uses  SysUtils;

{$I ACRErrorL.inc}
{$I ACRErrorA.inc}
{$I ACRErrorG.inc}
{$I ACRErrorR.inc}
{$I ACRErrorF.inc}

type  TACRSignature = Array [0..3] of Char;

const ACRVersionText = '';
// const     ACRVersionText = 'Prerelease Version #4';
{$IFDEF SQLMEMTABLE}
const ACRVersion = 3.02; // SQLMemTable
{$ELSE}
const ACRVersion = 4.02; // Accuracer
//      ACRVersionText = '';
const ACRMaxVersion = 100.00001; // for disk engine
      ACRMinVersion = 1.299999; // for disk engine
{$ENDIF}
//      ACRDiskSignature = 'ACS2';
      ACRSignature = 'ACS1';
      ACRDiskPageSignature = 'ACSP';
      ACRInternalDBFileSignature = 'ACSF';
      ACRBackupSignature = 'ACRB';
      ACRMemoryDatabaseName = 'MEMORY';
      ACRTemporaryDatabaseName = 'TEMP';
      ACRTemporaryIndexName = 'TEMPORARY_INDEX_';
      ACRTemporaryTableIndexName = 'TEMPORARY_TABLE_INDEX_';
      ACRTemporaryTableName = 'TEMPORARY_TABLE_';
      ACRExpressionFieldName = 'Expr';
      ACRDefaultIndexName = 'Index';
      ACRConstraintFKName = 'FOREIGN_KEY_';
const ACRConstraintFKTemporaryNamePrefix = 'ACRFKTNP_';      
const ACRDiskSignature1 = 'A';
const ACRDatabaseFileExtension = '.adb';
const ACRBackupFileExtension = '.abk';
var  ACRDiskSignature: TACRSignature = #0+'CS2'; // invalid first symbol
const ACRPSQuoteChar = ' @ ';

const ACRServerConfigFileExtension = '.ini';
const
{$IFDEF TRIAL_VERSION}
 {$IFDEF TRIAL_VERSION_WITHOUT_NAG_SCREEN}
  {$IFDEF TRIAL_VERSION_WITH_FULL_SQL}
     ACRBuildInfo = 'Trial Without Nag-Screen Full SQL';
  {$ELSE}
     ACRBuildInfo = 'Trial Without Nag-Screen Only SELECT';
  {$ENDIF}
 {$ELSE}
  {$IFDEF TRIAL_VERSION_WITH_FULL_SQL}
    ACRBuildInfo = 'Trial With Nag-Screen Full SQL';
  {$ELSE}
    ACRBuildInfo = 'Trial With Nag-Screen Only SELECT';
  {$ENDIF}
 {$ENDIF}
{$ELSE}
 ACRBuildInfo = 'Full';
{$ENDIF}


//------------------------------------------------------------------------------
// ACRVariant
//------------------------------------------------------------------------------
{$IFDEF LINUX}
// const MAX_INTEGER = 2147483647;
 const MAX_STRING_LENGTH = 99 * 1024; // To avoid memory problem with old libc.so
// 4 * 1024 * 1024 - 4 - 1;  // WideAnsiUpperCase works slow
// 2147483647 div 32 - 4; // really works, but too slow
{$ENDIF}
 const ACRExpressionMaxStringSize = 255;
//------------------------------------------------------------------------------
// Connection consts
//------------------------------------------------------------------------------

// Maximum threads number
 ACRMaxThreadCount = 100;

//------------------------------------------------------------------------------

// Allow connection parameters auto correction
 ACRConnectionParamsTunning = False;
// ACRConnectionParamsTunning = True;

// Number of packets to test network for connection parameters auto tunning
 ACRTestPacketCount = 8;

// To connect - Client only
 ACRConnectRetryCount = 20;       // - Client only
 ACRConnectDelay = 500;            // - Client only

// To receive full session buffer
 ACRStartReceiveTimeOut = 60000;    // - Client only, time to wait for the first packet in answer
 ACRReceiveTimeOut = 600000;        // - Client only, time since the first packet to the latest
 ACRReceiveSleep = 1;               // - Client only, time to sleep while receive buffer to allow incoming packets processing, >=0, <= 100
 ACRServerReceiveTimeOut = 300000;  // - Server only
 ACRServerReceiveSleep = 1;         // - Server only   >=0, <= 100

// To send buffer
 ACRMinSendTimeOut =       10000;   // - Client only
 ACRSendTimeOut =         180000;        // - Client only
 ACRMinServerSendTimeOut = 60000;        // - Server only
 ACRServerSendTimeOut   = 600000;        // - Server only

// To send new request to ask other side to resend broken packet
 ACRWaitForSendSleep = 0;        // - Client only, time to sleep while wait for all packets sent in packet resending, =0 for best speed
 ACRResendDelay = 300;           // - Client only, delay (msec) before resend requested packet, >=1, <= 100
 ACRRequestDelay = 300;          // - Client only, delay (msec) before request lost packet, >=1, <= 100
 ACRServerWaitForSendSleep = 0;  // - Server only, =0 for best speed
 ACRServerResendDelay = 200;     // - Server only, >0, <= 100
 ACRServerRequestDelay = 100;    // - Server only, >=0, <= 100

// To Diconnect
 ACRDisconnectRetryCount = 10;   // Both Client and Server
 ACRDisconnectDelay = 300;       // Both Client and Server

//------------------------------------------------------------------------------

// Wait for end of all other sessions messages sending
 ACRWaitForMessagesSend = 300000;   // Server only

// Wait for Session finishing
 ACRWaitForTimeOut = 120000;        // Client only
// Wait for Server Session Thread finishing
 ACRWaitForServerSessionThreadTimeOut = 120000;    // Server only

// Wait for other threads finish to free shared object
 ACRThreadsTerminateDelay = 30000;         // Client
 ACRServerThreadsTerminateDelay = 10000;   // Server

// Pause between loops
 ACRServerSessionTerminatorSleep = 0; // Server

// Enable/Disable disconect by timeout
 ACRPingClients = True;        // Server
// Wait for alive confirmation
 ACRWaitForPingAnswer = 60000; // Server
// Pause between pings
 ACRServerPingSleep      = 20; // Server, >=1, low priority thread

//------------------------------------------------------------------------------

 const ACRMinPacketSize = 128;  // PacketHeader = 33
 const ACRMaxPacketSize = 65507;    // 65507 - maximum allowed //64512;//32768;//16384;
 const ACRDefaultPacketSize = 8192;
 const ACRDefaultClientPort = 12008;
 const ACRDefaultServerPort = 12007;// Cannot be the same as ACRDefaultClientPort

 const ACRDefaultAuthorizationBufferSize = 512;
 const ACRDefaultServerID = 0;
 const ACRDefaultHost = '127.0.0.1';  // 'localhost' - delay about 100 msec to resolve
 const ACRDefaultServerHost = '';     // 'localhost' - delay about 100 msec to resolve

 const ACRServerDescription = 'Accuracer Database Server';
 const ACRDefaultServerConfigFileName = 'AccuracerDatabaseServer.ini';
 const ACRDefaultDBName = 'DBDemos';
 const ACRDefaultDBFileName = '..\..\..\Demos\Data\DBDemos.adb';

//------------------------------------------------------------------------------
// lock consts
//------------------------------------------------------------------------------

 const ACRDefaultServerLockRetryCount = 100;
 const ACRDefaultServerLockDelay = 10;

//------------------------------------------------------------------------------
// disk consts
//------------------------------------------------------------------------------

{$IFDEF LINUX}
 const INVALID_FILE_SIZE = -1;
 const INVALID_HANDLE_VALUE = -1;
{$ENDIF}
 var ACRDefaultTempDir: String;
 var ACRDefaultPageMangerCacheCapactiy: Integer = 30;
 var ACRDefaultMemoryPageSize: Integer = 4096;
 var ACRDefaultTemporaryPageSize: Integer = 4096;
 var ACRDefaultMemoryTableAllocBy: Integer = 1000;
 const ACRMaxIndexHeaderSize = 128;
 const ACRDefaultPageSize = 4096;
 const ACRMinPageSize = 128;
 const ACRMaxPageSize = 65535; // 65535;
 const ACRDefaultExtentPageCount = 8;
 const ACRMinExtentPageCount = 4;
 const ACRMaxExtentPageCount = 100;
 const DefaultDBHeaderReserved = 0;
 const DefaultLockedBytesReserved = 0;
 const DefaultLockedBytesCount = 2;
 const ACRDefaultRetryCount = 10;
 const ACRDefaultDelay = 500; // ms
 const ACRMinRetryCount = 1;
 const ACRMinDelay = 0;
 const ACRMAXLastLockRetryTime = 2000; // ms
 const ACRMAXLockFileTime = 2500; // ms  > ACRMAXLastLockRetryTime
 const ACRMinRandomSearchRetryCount = 1;
 const ACRMaxRandomSearchRetryCount = 100;
 const ACRDefaultRandomSearchRetryCount = 10;
 const OffsetToFreeSpaceManagerLockByte = 0;
 const OffsetToTablesLockByte = 1;
 const ACRMinSystemFilesCount = 2;
 const ACRVarcharSlowDownRate = 5;
 const ACRDefaultBackupBlockSize = ACRDefaultPageSize * 25; // 100 Kb

{$IFDEF FILE_SERVER_VERSION}
  {$IFDEF TRIAL_VERSION}
     const ACRMaxSessionCount = 2;
    const ACRDefaultSessionCount = 2;
    const ACRMaxSingleUserConnections = 5;
  {$ELSE}
    const ACRMaxSessionCount = 1000000;// 1M
    const ACRDefaultSessionCount: Integer = (ACRDefaultPageSize - 40 - 12) div 11;// ACRMinPageSize ; // 4040
    const ACRMaxSingleUserConnections = 1000000; // 1M
  {$ENDIF}
{$ELSE}
 const ACRMaxSessionCount = 1;
  const ACRDefaultSessionCount = 1;
  {$IFDEF TRIAL_VERSION}
  const ACRMaxSingleUserConnections = 5;
  {$ELSE}
  const ACRMaxSingleUserConnections = 1000000; // 1M
  {$ENDIF}
{$ENDIF}
 // Maximum number of LockTypes
 const ACRMaxLockTypes = 5;

 // System First Pages
 const

{$IFDEF FREE_SPACE_MANAGER_ON}
        ACRFirstPageNoPFS = 0;
        ACRFirstPageNoGAM = 1;
        ACRFirstPageNoSGAM = 2;
        ACRFirstPageNoSystemDirectory = 3;
{$ELSE}
        ACRFirstPageNoGAM = 0;
        ACRFirstPageNoSGAM = 1;
        ACRFirstPageNoPFS = 2;
        ACRFirstPageNoSystemDirectory = 0;
{$ENDIF}

 const ACRObjectIDUnknown = -1;
 const ACRObjectIDSystemDirectory = -2;
 const ACRObjectIDActiveSessionsFile = -3;
 const ACRObjectIDTableListFile = -4;
 const ACRObjectIDFreeSpaceManager = -5;

 // Page Types
 const
        ACRPageTypeIDUnknown =              0;
        ACRPageTypeIDEmpty =                1;
        ACRPageTypeIDGAM =                  2;
        ACRPageTypeIDSGAM =                 3;
        ACRPageTypeIDPFS =                  4;
        ACRPageTypeIDFileSystemDirectory =  5;
        ACRPageTypeIDActiveSessionList =    6;
        ACRPageTypeIDTableList =            7;
        ACRPageTypeIDTablePFSMap =          8;
        ACRPageTypeIDTableLocksFile =       9;
        // varchar or blob page with multiple items on the page
        ACRPageTypeIDTableDataSmall =       10;
        // varchar or blob page with single item on the page
        ACRPageTypeIDTableDataLarge =       11;
        ACRPageTypeIDTableRows =            12;
        ACRPageTypeIDTablePFS =             13;
        ACRPageTypeIDTableMetadata =        14;
        ACRPageTypeIDTableMostUpdated =     15;
        ACRPageTypeIDIndexData =            16;

        ACRPageTypeIDLast =                 16;

 ACRPageTypeNames: array [0..15] of String = (
        'PageTypeIDUnknown',
        'PageTypeIDEmpty',
        'PageTypeIDGAM',
        'PageTypeIDSGAM',
        'PageTypeIDPFS',
        'PageTypeIDFileSystemDirectory',
        'PageTypeIDActiveSessionList',
        'PageTypeIDTableList',
        'PageTypeIDTablePFSMap',
        'PageTypeIDTableLocks',
        'PageTypeIDTableDataSmall',
        'PageTypeIDTableDataLarge',
        'PageTypeIDTableRows',
        'PageTypeIDTablePFS',
        'ACRPageTypeIDTableMetadata',
        'ACRPageTypeIDTableMostUpdated'
        );

 const ACRTablePFSItemSize = 18; // bits
 const ACRTablePFSEmptyPage = $FFFF;

//------------------- ENCRYPTION CONSTS -------------------------------------------

const ACR_Cipher_None = 0;
const ACR_Cipher_Rijndael_128 = 1;
const ACR_Cipher_Rijndael_256 = 2;
const ACR_Cipher_Blowfish = 3;
const ACR_Cipher_Twofish_128 = 4;
const ACR_Cipher_Twofish_256 = 5;
const ACR_Cipher_Square = 6;
const ACR_Cipher_Des_Single_8 = 7;
const ACR_Cipher_Des_Double_8 = 8;
const ACR_Cipher_Des_Double_16 = 9;
const ACR_Cipher_Des_Triple_8 = 10;
const ACR_Cipher_Des_Triple_16 = 11;
const ACR_Cipher_Des_Triple_24 = 12;

const ACR_Cipher_Mode_CTS = 0;
const ACR_Cipher_Mode_CBC = 1;
const ACR_Cipher_Mode_CFB = 2;
const ACR_Cipher_Mode_OFB = 3;

const ACR_MAX_VECTOR = 31;
const ACR_MAX_KEY = 55;
const ACR_MAX_CONTROL_BLOCK = 255;

const ACRDefaultPassword = 'ACRpassword';

//------------------- GENERAL CONSTS -------------------------------------------

 const ACRDefaultCommitCount = 1000;
 // Invalid ID - returned by find methods in case if object was not found
 const MAX_NAME_LENGTH = 255;
 const INVALID_ID8 = Int64(-1);
 const INVALID_ID4 = Integer(-1);
 const OBJECTID_IS_NULL = Integer(-1);
 const INVALID_PAGE_NO = Integer(-1);
 const INVALID_OBJECT_ID = INVALID_ID4;
 const INVALID_PAGE_RECORD_NO = $FFFF;
 const ACR_BLOB_NOT_MODIFIED = $F0F0;
 const ACR_BLOB_MODIFIED = $0F0F;
 // DateTime Const
 const TIME_IS_NULL = -1;
// Bug fix in 4.02: time can be set to 0, but not to < 0 
// const TIME_IS_NULL = 0;//MaxInt;
{$WARNINGS OFF}
// const DATE_IS_NULL: Cardinal = $80000000;
 const DATE_IS_NULL: Integer = Integer($80000000);
{$WARNINGS ON}
 const MILSECS_IN_DAY = 24*60*60*1000;

 // BTree
 const BTreeNullFlagSize = 1;
 const BTreeKeyIsNull    = #1;
 const BTreeKeyIsNotNull = #0;

 const INVALID_SESSION_ID = Integer(-1);
 const SYSTEM_SESSION_ID = Integer(-2);

 // error codes

 const ACR_ERR_OK = 0;
 const ACR_ERR_INSERT_RECORD = -1;
 const ACR_ERR_UPDATE_RECORD = -2;
 const ACR_ERR_DELETE_RECORD = -3;
 const ACR_ERR_UPDATE_RECORD_MODIFIED = -4;
 const ACR_ERR_DELETE_RECORD_MODIFIED = -5;
 const ACR_ERR_UPDATE_RECORD_DELETED = -6;
 const ACR_ERR_DELETE_RECORD_DELETED = -7;

 const ACR_ERR_CONSTRAINT_VIOLATED = -8;
 const ACR_ERR_UPDATE_RECORD_PROHIBITED = -9;
 const ACR_ERR_DELETE_RECORD_PROHIBITED = -10;
 const ACR_ERR_CANCEL_PROHIBITED = -11;

 // ASC, DESC, CASE INSENSITIVITY constants
 const ACR_ASC = 'ASC';
       ACR_DESC = 'DESC';
       ACR_NO_CASE = 'NO_CASE';
       ACR_CASE = 'CASE';

 // Auto generation object names
 const
       AutoNameSymbol = '$';
       AutoNameSequenceAutoIncPrefix = 'S_Autoinc';
       AutoNameSequenceLinkedWithColumnPrefix = 'S_Linked';
       AutoNameConstraintNotNullPrefix = 'C_NotNull';
       AutoNameConstraintCheckPrefix = 'C_Check';
       AutoNameConstraintPKPreffix = 'C_PK';
       AutoNameConstraintUniquePreffix = 'C_Unique';

// SQL Lexer constants

const Lf: string = #$0A;       // binary mode line separator
const Cr: string = #$0D;       // text mode line separator
const Crlf: string = #$0D#$0A; // text mode line separator
const Tab: string = #$09; // <tab>
const Comment = '-'; // -- comment <Crlf>
const Comment1 = '#'; // # comment <Crlf>
const Dot = '.';
const Comma = ',';
const SemiColon = ';';
const Asterisk = '*';
const SingleQuote = '''';
const DoubleQuote = '"';
const Space = ' ';
const LeftParenthesis = '(';
const RightParenthesis = ')';
const Percent = '%';
const LeftBracket = '[';
const RightBracket = ']';
const Colon = ':';

type
  TReservedWord =
  (
   rwABSOLUTE
   ,rwACTION
   ,rwADD
   ,rwALL
   ,rwALLOCATE
   ,rwALTER 
   ,rwAND 
   ,rwANY
   ,rwARE
   ,rwAS 
   ,rwASC 
   ,rwASSERTION
   ,rwAT
   ,rwAUTHORIZATION 
   ,rwAVG
   ,rwBEGIN 
   ,rwBETWEEN
   ,rwBIT 
   ,rwBIT_LENGTH
   ,rwBOTH 
   ,rwBY
   ,rwCASCADE 
   ,rwCASCADED 
   ,rwCASE
   ,rwCAST 
   ,rwCATALOG 
   ,rwCHAR 
   ,rwCHARACTER 
   ,rwCHAR_LENGTH 
   ,rwCHARACTER_LENGTH
   ,rwCHECK
   ,rwCLOSE
   ,rwCOALESCE
   ,rwCOLLATE
   ,rwCOLLATION 
   ,rwCOLUMN
   ,rwCOMMIT 
   ,rwCONNECT
   ,rwCONNECTION 
   ,rwCONSTRAINT 
   ,rwCONSTRAINTS
   ,rwCONTINUE 
   ,rwCONVERT
   ,rwCORRESPONDING 
   ,rwCOUNT 
   ,rwCREATE
   ,rwCROSS
   ,rwCURRENT 
   ,rwCURRENT_DATE 
   ,rwCURRENT_TIME 
   ,rwCURRENT_TIMESTAMP 
   ,rwCURRENT_USER 
   ,rwCURSOR 
   ,rwDATE 
   ,rwDAY
   ,rwDEALLOCATE
   ,rwDEC 
   ,rwDECIMAL
   ,rwDECLARE
   ,rwDEFAULT 
   ,rwDEFERRABLE
   ,rwDEFERRED
   ,rwDELETE 
   ,rwDESC 
   ,rwDESCRIBE 
   ,rwDESCRIPTOR
   ,rwDIAGNOSTICS
   ,rwDISCONNECT 
   ,rwDISTINCT
   ,rwDOMAIN
   ,rwDOUBLE 
   ,rwDROP 
   ,rwELSE
   ,rwEND
   ,rwEND_EXEC
   ,rwESCAPE 
   ,rwEXCEPT 
   ,rwEXCEPTION 
   ,rwEXEC 
   ,rwEXECUTE
   ,rwEXISTS 
   ,rwEXTERNAL 
   ,rwEXTRACT 
   ,rwFALSE
   ,rwFETCH
   ,rwFIRST
   ,rwFLOAT 
   ,rwFOR
   ,rwFOREIGN
   ,rwFOUND
   ,rwFROM 
   ,rwFULL 
   ,rwGET
   ,rwGLOBAL
   ,rwGO
   ,rwGOTO
   ,rwGRANT
   ,rwGROUP
   ,rwHEX 
   ,rwHAVING
   ,rwHOUR
   ,rwIDENTITY 
   ,rwIF
   ,rwIMMEDIATE
   ,rwIN 
   ,rwINDICATOR 
   ,rwINITIALLY 
   ,rwINNER 
   ,rwINPUT
   ,rwINSENSITIVE 
   ,rwINSERT 
   ,rwINT
   ,rwINTEGER
   ,rwINTERSECT
   ,rwINTERVAL
   ,rwINTO 
   ,rwIS 
   ,rwISOLATION
   ,rwJOIN
   ,rwKEY 
   ,rwLANGUAGE 
   ,rwLAST 
   ,rwLEADING
   ,rwLEFT
   ,rwLEVEL
   ,rwLIKE
   ,rwLOCAL
   ,rwLOWER 
   ,rwMATCH
   ,rwMAX 
   ,rwMEMORY
   ,rwMIME64
   ,rwMIN
   ,rwMINUS
   ,rwMINUTE
   ,rwMODULE
   ,rwMONTH
   ,rwNAMES
   ,rwNATIONAL
   ,rwNATURAL
   ,rwNCHAR
   ,rwNEXT
   ,rwNO
   ,rwNOFLUSH
   ,rwNOT
   ,rwNULL
   ,rwNULLIF
   ,rwNUMERIC
   ,rwOCTET_LENGTH
   ,rwOF
   ,rwON
   ,rwONLY
   ,rwOPEN
   ,rwOPTION
   ,rwOR
   ,rwORDER
   ,rwOUTER
   ,rwOUTPUT
   ,rwOVERLAPS
   ,rwPAD
   ,rwPARTIAL
   ,rwPOSITION
   ,rwPRECISION
   ,rwPREPARE
   ,rwPRESERVE
   ,rwPRIMARY
   ,rwPRIOR
   ,rwPRIVILEGES
   ,rwPROCEDURE
   ,rwPUBLIC
   ,rwREAD
   ,rwREAL
   ,rwREFERENCES
   ,rwRELATIVE
   ,rwRESTRICT
   ,rwREVOKE
   ,rwRIGHT
   ,rwROLLBACK
   ,rwROWS
   ,rwSCHEMA
   ,rwSCROLL
   ,rwSECOND
   ,rwSECTION
   ,rwSELECT
   ,rwSESSION
   ,rwSESSION_USER
   ,rwSET
   ,rwSIZE
   ,rwSMALLINT
   ,rwSOME
   ,rwSPACE
   ,rwSQL
   ,rwSQLCODE
   ,rwSQLERROR
   ,rwSQLSTATE
   ,rwSTART
   ,rwSUBSTRING
   ,rwSUM
   ,rwSYSTEM_USER
   ,rwTABLE
   ,rwTEMPORARY
   ,rwTHEN
   ,rwTIME
   ,rwTIMESTAMP
   ,rwTIMEZONE_HOUR
   ,rwTIMEZONE_MINUTE
   ,rwTO
   ,rwTOP
   ,rwTRAILING
   ,rwTRANSACTION
   ,rwTRANSLATE
   ,rwTRANSLATION
   ,rwTRIM
   ,rwTRUE
   ,rwUNION
   ,rwUNIQUE
   ,rwUNKNOWN
   ,rwUPDATE
   ,rwUPPER
   ,rwUSAGE
   ,rwUSER
   ,rwUSING
   ,rwVALUE
   ,rwVALUES
   ,rwVARCHAR
   ,rwVARYING
   ,rwVIEW
   ,rwWHEN
   ,rwWHENEVER
   ,rwWHERE
   ,rwWITH
   ,rwWORK
   ,rwWRITE
   ,rwYEAR
   ,rwZONE
   ,rwPASSWORD                // for DDL commands
   ,rwBLOBBLOCKSIZE           // for DDL commands
   ,rwBLOBCOMPRESSIONMODE     // for DDL commands
   ,rwBLOBCOMPRESSIONALGORITHM// for DDL commands
   ,rwLAST_AUTOINC            // for DDL commands
   ,rwMODIFY                  // alter table blablabla modify ...
   ,rwNEW                     // for NEW PASSWORD in ALTER TABLE
   ,rwINDEX                   // for CREATE INDEX ...
   ,rwNOCASE                  // for CREATE INDEX ... NOCASE
   ,rwLTRIM
   ,rwRTRIM
   ,rwPOS
   ,rwLENGTH
   ,rwSYSDATE
   ,rwNOW
   ,rwTOBLOB
   ,rwTODATE
   ,rwTOSTRING
   ,rwAUTOINDEXES
   ,rwNOAUTOINDEXES
   ,rwINCREMENT
   ,rwLASTVALUE
   ,rwMAXVALUE
   ,rwMINVALUE
   ,rwCYCLED
   ,rwNOMAXVALUE
   ,rwNOMINVALUE
   ,rwNOCYCLED
   ,rwINITIALVALUE
   ,rwRENAME
   ,rwNone
  );

const
  ACRMaxSQLReservedWords = 264;
  ACRSQLReservedWords: array[0..ACRMaxSQLReservedWords] of String =
  (
   'ABSOLUTE'
   ,'ACTION'
   ,'ADD'
   ,'ALL'
   ,'ALLOCATE'
   ,'ALTER'
   ,'AND'
   ,'ANY'
   ,'ARE'
   ,'AS'
   ,'ASC'
   ,'ASSERTION'
   ,'AT'
   ,'AUTHORIZATION'
   ,'AVG'
   ,'BEGIN'
   ,'BETWEEN'
   ,'BIT'
   ,'BIT_LENGTH'
   ,'BOTH'
   ,'BY'
   ,'CASCADE'
   ,'CASCADED'
   ,'CASE'
   ,'CAST'
   ,'CATALOG'
   ,'CHAR'
   ,'CHARACTER'
   ,'CHAR_LENGTH'
   ,'CHARACTER_LENGTH'
   ,'CHECK'
   ,'CLOSE'
   ,'COALESCE'
   ,'COLLATE'
   ,'COLLATION'
   ,'COLUMN'
   ,'COMMIT'
   ,'CONNECT'
   ,'CONNECTION'
   ,'CONSTRAINT'
   ,'CONSTRAINTS'
   ,'CONTINUE'
   ,'CONVERT'
   ,'CORRESPONDING'
   ,'COUNT'
   ,'CREATE'
   ,'CROSS'
   ,'CURRENT'
   ,'CURRENT_DATE'
   ,'CURRENT_TIME'
   ,'CURRENT_TIMESTAMP'
   ,'CURRENT_USER'
   ,'CURSOR'
   ,'DATE'
   ,'DAY'
   ,'DEALLOCATE'
   ,'DEC'
   ,'DECIMAL'
   ,'DECLARE'
   ,'DEFAULT'
   ,'DEFERRABLE'
   ,'DEFERRED'
   ,'DELETE'
   ,'DESC'
   ,'DESCRIBE'
   ,'DESCRIPTOR'
   ,'DIAGNOSTICS'
   ,'DISCONNECT'
   ,'DISTINCT'
   ,'DOMAIN'
   ,'DOUBLE'
   ,'DROP'
   ,'ELSE'
   ,'END'
   ,'END-EXEC'
   ,'ESCAPE'
   ,'EXCEPT'
   ,'EXCEPTION'
   ,'EXEC'
   ,'EXECUTE'
   ,'EXISTS'
   ,'EXTERNAL'
   ,'EXTRACT'
   ,'FALSE'
   ,'FETCH'
   ,'FIRST'
   ,'FLOAT'
   ,'FOR'
   ,'FOREIGN'
   ,'FOUND'
   ,'FROM'
   ,'FULL'
   ,'GET'
   ,'GLOBAL'
   ,'GO'
   ,'GOTO'
   ,'GRANT'
   ,'GROUP'
   ,'HEX'
   ,'HAVING'
   ,'HOUR'
   ,'IDENTITY'
   ,'IF'
   ,'IMMEDIATE'
   ,'IN'
   ,'INDICATOR'
   ,'INITIALLY'
   ,'INNER'
   ,'INPUT'
   ,'INSENSITIVE'
   ,'INSERT'
   ,'INT'
   ,'INTEGER'
   ,'INTERSECT'
   ,'INTERVAL'
   ,'INTO'
   ,'IS'
   ,'ISOLATION'
   ,'JOIN'
   ,'KEY'
   ,'LANGUAGE'
   ,'LAST'
   ,'LEADING'
   ,'LEFT'
   ,'LEVEL'
   ,'LIKE'
   ,'LOCAL'
   ,'LOWER'
   ,'MATCH'
   ,'MAX'
   ,'MEMORY'
   ,'MIME64'
   ,'MIN'
   ,'MINUS'
   ,'MINUTE'
   ,'MODULE'
   ,'MONTH'
   ,'NAMES'
   ,'NATIONAL'
   ,'NATURAL'
   ,'NCHAR'
   ,'NEXT'
   ,'NO'
   ,'NOFLUSH'
   ,'NOT'
   ,'NULL'
   ,'NULLIF'
   ,'NUMERIC'
   ,'OCTET_LENGTH'
   ,'OF'
   ,'ON'
   ,'ONLY'
   ,'OPEN'
   ,'OPTION'
   ,'OR'
   ,'ORDER'
   ,'OUTER'
   ,'OUTPUT'
   ,'OVERLAPS'
   ,'PAD'
   ,'PARTIAL'
   ,'POSITION'
   ,'PRECISION'
   ,'PREPARE'
   ,'PRESERVE'
   ,'PRIMARY'
   ,'PRIOR'
   ,'PRIVILEGES'
   ,'PROCEDURE'
   ,'PUBLIC'
   ,'READ'
   ,'REAL'
   ,'REFERENCES'
   ,'RELATIVE'
   ,'RESTRICT'
   ,'REVOKE'
   ,'RIGHT'
   ,'ROLLBACK'
   ,'ROWS'
   ,'SCHEMA'
   ,'SCROLL'
   ,'SECOND'
   ,'SECTION'
   ,'SELECT'
   ,'SESSION'
   ,'SESSION_USER'
   ,'SET'
   ,'SIZE'
   ,'SMALLINT'
   ,'SOME'
   ,'SPACE'
   ,'SQL'
   ,'SQLCODE'
   ,'SQLERROR'
   ,'SQLSTATE'
   ,'START'
   ,'SUBSTRING'
   ,'SUM'
   ,'SYSTEM_USER'
   ,'TABLE'
   ,'TEMPORARY'
   ,'THEN'
   ,'TIME'
   ,'TIMESTAMP'
   ,'TIMEZONE_HOUR'
   ,'TIMEZONE_MINUTE'
   ,'TO'
   ,'TOP'
   ,'TRAILING'
   ,'TRANSACTION'
   ,'TRANSLATE'
   ,'TRANSLATION'
   ,'TRIM'
   ,'TRUE'
   ,'UNION'
   ,'UNIQUE'
   ,'UNKNOWN'
   ,'UPDATE'
   ,'UPPER'
   ,'USAGE'
   ,'USER'
   ,'USING'
   ,'VALUE'
   ,'VALUES'
   ,'VARCHAR'
   ,'VARYING'
   ,'VIEW'
   ,'WHEN'
   ,'WHENEVER'
   ,'WHERE'
   ,'WITH'
   ,'WORK'
   ,'WRITE'
   ,'YEAR'
   ,'ZONE'
   ,'PASSWORD'              // for DDL commands
   ,'BLOBBLOCKSIZE'         // for DDL commands
   ,'BLOBCOMPRESSIONMODE'   // for DDL commands
   ,'BLOBCOMPRESSIONALGORITHM'// for DDL commands
   ,'LASTAUTOINC'           // for DDL commands
   ,'MODIFY'                // alter table blablabla modify ...
   ,'NEW'                   // for NEW PASSWORD in ALTER TABLE
   ,'INDEX'                 // for CREATE INDEX ...
   ,'NOCASE'                // for CREATE INDEX ... NOCASE ..
   ,'LTRIM'
   ,'RTRIM'
   ,'POS'
   ,'LENGTH'
   ,'SYSDATE'               // DateTime function
   ,'NOW'
   ,'TOBLOB'                // TOBLOB function
   ,'TODATE'                // TODATE function
   ,'TOSTRING'                // TOSTRING function
   ,'AUTOINDEXES'           // for DDL AutoIndexes
   ,'NOAUTOINDEXES'         // for DDL AutoIndexes
   ,'INCREMENT'
   ,'LASTVALUE'
   ,'MAXVALUE'
   ,'MINVALUE'
   ,'CYCLED'
   ,'NOMAXVALUE'
   ,'NOMINVALUE'
   ,'NOCYCLED'
   ,'INITIALVALUE'
   ,'RENAME'

  );


implementation

initialization

ACRDiskSignature[0] := ACRDiskSignature1;

end.
