{$I ACRVer.inc}

unit ACRExcept;

interface

uses SysUtils, Classes,
 {$IFDEF DEBUG_LOG}
     ACRDebug,
 {$ENDIF}
     ACRConst;

type


////////////////////////////////////////////////////////////////////////////////
//
// EACRException
//
////////////////////////////////////////////////////////////////////////////////


  EACRException = class( Exception )
  public
    NativeError: Integer;

    constructor Create(NativeErrorCode: Integer; ErrorMsg: String); overload;
    constructor Create(NativeErrorCode: Integer; ErrorMsg: String; const Args: array of const); overload;
  end; // EACRException

implementation


//------------------------------------------------------------------------------
// constructor
//------------------------------------------------------------------------------
constructor EACRException.Create(NativeErrorCode: Integer; ErrorMsg: String);
var
  ErMessage: string;
begin
  NativeError := NativeErrorCode;
  ErMessage := ErrorMsg;
  ErMessage := ErMessage + ' - Native error: '+ Format('%.5d',[NativeErrorCode]);
  inherited Create(ErMessage);
end; // Create


//------------------------------------------------------------------------------
// constructor
//------------------------------------------------------------------------------
constructor EACRException.Create(NativeErrorCode: Integer; ErrorMsg: String; const Args: array of const);
var
  ErMessage: string;
begin
  NativeError := NativeErrorCode;
  try
    ErMessage := Format(ErrorMsg, Args);
  except
    ErMessage := ErrorMsg + ' Arguments are invalid!';
  end;
  ErMessage := ErMessage + ' - Native error: ' + Format('%5d',[NativeErrorCode]);
  inherited Create(ErMessage);
end; // Create

initialization

{$IFDEF DEBUG_LOG_INIT}
aaWriteToLog('ACRBaseEngine> initialized');
{$ENDIF}

end.
